; PARCP Transfer Routines by Petr Stehlik -  http://joy.sophics.cz/parcp/

; Server side only


YAMAHA	= $ffff8800		* reg. A0
*       = $ffff8802		* reg. A1
GPIP	= $fffffa01		* reg. A2
CLOCK	= $4ba			* reg. A3
*       = buffer		* reg. A4

* D0 - temporary register; can be used inside loop
* D1 - keeps original contents of SR;
* D2 - counter of remaining length to transmit
* D3 - number 15, for quicker writting to Yamaha regs.
* D4 - ym port 14 - strobe high
* D5 - ym port 14 - strobe low
* D6 - #0 for btst
* A5 - oldstack

BDIRECT	= 7
BSTROBE	= 5

;		section	code

RYCHLY	= 1				* rychly dotaz na zacatku WAIT_xxx

RUPT	SET			1	* na zacatku jsou preruseni povolena

MAC_CLI		MACRO
		IFNE		RUPT
RUPT	SET			0
		move.w		sr,d1
		or.w		#$700,sr
		ENDC
		ENDM

MAC_STI		MACRO
		IFEQ		RUPT
RUPT	SET			1
		move.w		d1,sr
		ENDC
		ENDM

MAC_SET_INPUT	MACRO
		move.l		#$07004000,(a0)
		ENDM

MAC_SET_OUTPUT	MACRO
		move.l		#$0700C000,(a0)
		ENDM

MAC_STROBE_HIGH	MACRO
		move.l		d4,(a0)
		ENDM

MAC_STROBE_LOW	MACRO
		move.l		d5,(a0)
		ENDM

MAC_IS_READY	MACRO
		btst		d6,(a2)
		ENDM

MAC_GET_BYTE	MACRO
		move.b		d3,(a0)
		move.b		(a0),(a4)+
		ENDM

MAC_PUT_BYTE	MACRO
		move.b		d3,(a0)
		move.b		(a4)+,(a1)
		ENDM

MAC_WAIT_LOW_F:	MACRO
.loop\@		MAC_IS_READY
		bne.s		.loop\@
		ENDM
MAC_WAIT_HIGH_F: MACRO
.loop\@		MAC_IS_READY
		beq.s		.loop\@
		ENDM

MAC_GODMODE		MACRO
		clr.l		-(sp)
		move		#32,-(sp)
		trap		#1
		addq		#6,sp
		move.l		d0,a5
		ENDM

MAC_USERMODE	MACRO
		move.l		a5,-(sp)
		move		#32,-(sp)
		trap		#1
		addq		#6,sp
		ENDM

MAC_SAVE_REGS	MACRO
		movem.l		a0-a5/d0-d6,-(sp)
		endm

MAC_RESTORE_REGS	MACRO
		movem.l		(sp)+,a0-a5/d0-d6
		ENDM

MAC_GET_PARAMETERS	MACRO
		move.l		a0,a4		/* buffer pointer */
		move.l		d0,d2		/* size */
		asr.l		#2,d2		/* in long words */
		ENDM

MAC_SET_REGISTERS		MACRO
		lea		YAMAHA,a0
		lea		2(a0),a1
		lea		GPIP,a2
		lea		CLOCK,a3
		moveq		#15,d3
		move.l		#$0e000000,d4
		move.b		#14,(a0)
		move.b		(a0),d4
		lsl.w		#8,d4
		move.l		d4,d5
		or.w		#$2000,d4
		and.w		#%1101111100000000,d5
		moveq		#0,d6
		ENDM

*********************************************************************
fast_server_read_block:
		MAC_SAVE_REGS
		MAC_GET_PARAMETERS
		MAC_GODMODE
		MAC_SET_REGISTERS
		MAC_SET_INPUT
		MAC_CLI
		bra.s		.cyklus

.se_re	
		MAC_WAIT_HIGH_F
		MAC_GET_BYTE
		MAC_STROBE_HIGH
	 	MAC_WAIT_LOW_F
		MAC_GET_BYTE
		MAC_STROBE_LOW
		MAC_WAIT_HIGH_F
		MAC_GET_BYTE
		MAC_STROBE_HIGH
.cyklus 	MAC_WAIT_LOW_F
		MAC_GET_BYTE
		MAC_STROBE_LOW
		subq.l		#1,d2
		bge.s		.se_re

	  	MAC_WAIT_HIGH_F
		MAC_STROBE_HIGH
		MAC_STI
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#0,d0
		rts
*********************************************************************
fast_server_write_block:
		MAC_SAVE_REGS
		MAC_GET_PARAMETERS
		MAC_GODMODE
		MAC_SET_REGISTERS
		MAC_WAIT_LOW_F
		MAC_SET_OUTPUT
		MAC_CLI
		bra.s		.cyklus

.se_wr  	MAC_PUT_BYTE
		MAC_STROBE_HIGH
		MAC_WAIT_LOW_F
	 	MAC_PUT_BYTE
		MAC_STROBE_LOW
		MAC_WAIT_HIGH_F
	  	MAC_PUT_BYTE
		MAC_STROBE_HIGH
		MAC_WAIT_LOW_F
.cyklus 	MAC_PUT_BYTE
		MAC_STROBE_LOW
		MAC_WAIT_HIGH_F
		subq.l		#1,d2
		bge.s		.se_wr

	  	MAC_STROBE_HIGH
		MAC_SET_INPUT
		MAC_STI
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#0,d0
		rts
*********************************************************************
timeout:
		MAC_SET_INPUT
		MAC_STROBE_HIGH
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#-1,d0
		rts
set_input_strobe_high:
		MAC_SAVE_REGS
		MAC_GODMODE
		MAC_SET_REGISTERS
		MAC_SET_INPUT
		MAC_STROBE_HIGH
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#0,d0
		rts

get_busy_sup:
		moveq	#0,d0
		move.b	$fffffa01.w,d0
		and.b	#1,d0
		rts

