; PARCP Transfer Routines by Petr Stehlik -  http://joy.sophics.cz/parcp/

; Client side only

YAMAHA	= $ffff8800		* reg. A0
*       = $ffff8802		* reg. A1
GPIP	= $fffffa01		* reg. A2
CLOCK	= $4ba			* reg. A3
*       = buffer		* reg. A4

* reg. D0  - temporary register
* reg. D1  - keeps original contents of SR
* reg. D2  - counter of remaining length to transmit
* reg. D3  - number 15, for quicker writting to Yamaha regs.
* reg. D4  - Timeout, for quicker adding

BDIRECT	= 7
BSTROBE	= 5

		section	code

RYCHLY	= 1				* rychly dotaz na zacatku WAIT_xxx

RUPT	SET			1	* na zacatku jsou preruseni povolena

MAC_CLI		MACRO
		IFNE		RUPT
RUPT	SET			0
		move.w		sr,d1
		or.w		#$700,sr
		ENDC
		ENDM

MAC_STI		MACRO
		IFEQ		RUPT
RUPT	SET			1
		move.w		d1,sr
		ENDC
		ENDM

MAC_SET_CTRL	MACRO
		MAC_CLI
		move.b		\1,(a0)
		move.b		#(1<<\2),d0
		or.b		(a0),d0
		move.b		d0,(a1)
		MAC_STI
		ENDM

MAC_CLR_CTRL	MACRO
		MAC_CLI
		move.b		\1,(a0)
		move.b		#$ff-(1<<\2),d0
		and.b		(a0),d0
		move.b		d0,(a1)
		MAC_STI
		ENDM

MAC_SET_INPUT	MACRO
		MAC_CLR_CTRL	#7,BDIRECT
		ENDM

MAC_SET_OUTPUT	MACRO
		MAC_SET_CTRL	#7,BDIRECT
		ENDM

MAC_STROBE_HIGH	MACRO
		MAC_SET_CTRL	#14,BSTROBE
		ENDM

MAC_STROBE_LOW	MACRO
		MAC_CLR_CTRL	#14,BSTROBE
		ENDM

MAC_IS_READY	MACRO
		btst		#0,(a2)
		ENDM

MAC_GET_BYTE	MACRO
		MAC_CLI
		move.b		d3,(a0)
		move.b		(a0),(a4)+
		ENDM

MAC_PUT_BYTE	MACRO
		MAC_CLI
		move.b		d3,(a0)
		move.b		(a4)+,(a1)
		ENDM

MAC_WAIT_LOW:	MACRO
		IFNE		RYCHLY
		MAC_IS_READY
		beq.s		.end\@
		ENDC
		move.l		(a3),d0
		add.l		d4,d0
.loop\@	MAC_IS_READY
		beq.s		.end\@
		cmp.l		(a3),d0
		bne.s		.loop\@
		bra		timeout
.end\@
		ENDM

MAC_WAIT_HIGH:	MACRO
		IFNE		RYCHLY
		MAC_IS_READY
		bne.s		.end\@
		ENDC
		move.l		(a3),d0
		add.l		d4,d0
.loop\@	MAC_IS_READY
		bne.s		.end\@
		cmp.l		(a3),d0
		bne.s		.loop\@
		bra		timeout
.end\@
		ENDM

MAC_GODMODE		MACRO
		clr.l		-(sp)
		move		#32,-(sp)
		trap		#1
		addq		#6,sp
		move.l		d0,oldstack
		ENDM

MAC_USERMODE	MACRO
		move.l		oldstack,-(sp)
		move		#32,-(sp)
		trap		#1
		addq		#6,sp
		ENDM

MAC_SAVE_REGS	MACRO
		movem.l		a0-a4/d0-d4,-(sp)
		endm

MAC_RESTORE_REGS	MACRO
		movem.l		(sp)+,a0-a4/d0-d4
		ENDM

MAC_GET_PARAMETERS	MACRO
		move.l		a0,a4		/* buffer pointer */
		move.l		d0,d2		/* size */
		asr.l		#1,d2			/* tolik bajtu */
		ENDM

MAC_SET_REGISTERS		MACRO
		lea		YAMAHA,a0
		lea		2(a0),a1
		lea		GPIP,a2
		lea		CLOCK,a3
		moveq		#15,d3
		move.l		time_out,d4
		mulu		#200,d4
		ENDM

*********************************************************************
fast_client_read_block:
		MAC_SAVE_REGS
		MAC_GET_PARAMETERS
		MAC_GODMODE
		MAC_SET_REGISTERS
		MAC_SET_INPUT
		bra.s		.cyklus

.cl_re  	MAC_GET_BYTE
.cyklus 	MAC_STROBE_LOW
		MAC_WAIT_LOW
		MAC_GET_BYTE
		MAC_STROBE_HIGH
		MAC_WAIT_HIGH
		subq.l		#1,d2
		bge.s		.cl_re

.konec  	MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#0,d0
		rts
*********************************************************************
fast_client_write_block:
		MAC_SAVE_REGS
		MAC_GET_PARAMETERS
		MAC_GODMODE
		MAC_SET_REGISTERS
		MAC_SET_OUTPUT
		bra.s		.cyklus

.cl_wr  	MAC_PUT_BYTE
		MAC_STROBE_HIGH
		MAC_WAIT_HIGH
.cyklus 	MAC_PUT_BYTE
		MAC_STROBE_LOW
		MAC_WAIT_LOW
		subq.l		#1,d2
 		bge.s		.cl_wr

.konec  	MAC_STROBE_HIGH
		MAC_WAIT_HIGH
		MAC_SET_INPUT
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#0,d0
		rts
*********************************************************************
timeout:
		MAC_SET_INPUT
		MAC_STROBE_HIGH
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#-1,d0
		rts
set_input_strobe_high:
		MAC_SAVE_REGS
		MAC_GODMODE
		MAC_SET_REGISTERS
		MAC_SET_INPUT
		MAC_STROBE_HIGH
		MAC_USERMODE
		MAC_RESTORE_REGS
		moveq		#0,d0
		rts

get_busy_sup:
		moveq	#0,d0
		move.b	$fffffa01.w,d0
		and.b	#1,d0
		rts

		section	bss
oldstack: 	ds.l		1
time_out:	ds.l		1
