; PARRUN - directly receive into and execute from RAM via PARCP-USB
; by Daniel Illgen (insane.tscc.de)
; based upon PARCP by Petr Stehlik

	include	tosmacros.asm
	comment	head=7

	section	code
headersiz	equ	$1c
	move.l	4(sp),a0
	move.l	bp_hitpa(a0),d0
	sub.l	bp_lowtpa(a0),d0
	sub.l	#$10000,d0
	bmi	abortprg	;not enough memory
	move.l	d0,freemem

	tos_mshrinkinit

	tos_sversion	;$3000=falcon $1900=pexec7 $1500=pexec6
	rol.w	#8,d0	;$0015
	cmp.w	#$0015,d0
	bcc	.skiptoserr
	tos_cconws	toserr(pc)
	tos_cnecin
	tos_pterm0
.skiptoserr
	cmp.w	#$0019,d0
	bcc	.nopexec7
	move.w	#5,createmode
.nopexec7

	bsr	keyflushtos
	move.l	#5,time_out
	moveq	#0,d0
	tos_dgetdrv
	tos_dsetdrv	d0
	move.l	d0,drives

syncloop	
	tos_cconws	title(pc)
	bsr	syncclient
	tst.l	d0
	bmi.s	abortprg

	bsr	read_long
	cmp.l	#"PRUN",d0
	beq.s	.runok

	tos_cconws	wrongclient(pc)
	bra.s	syncloop

.runok	
	move.l	#"OKAY",d0
	bsr	write_long
mainloop
	bsr	read_long
	cmp.l	#"CDIR",d0
	beq	do_chdir
	cmp.l	#"PROG",d0
	beq	do_rxprog

	bsr	test_abort
	bne	mainloop
abortprg
	bsr	keyflushtos
	tos_cconws done(pc)
	tos_pterm0

do_chdir
	bsr	read_long
	lea	buf(pc),a0
	bsr	fast_server_read_block
.chgdir	; change / into \
	cmp.b	#'/',(a0)
	bne.s	.skipchg
		move.b	#$5c,(a0)
.skipchg
	cmp.b	#0,(a0)+
	bne	.chgdir

	lea	buf(pc),a0
;test for drive:
	cmp.b	#':',1(a0)
	bne	.skipchdrv
		moveq	#0,d1
		move.b	(a0),d1
		lea	2(a0),a0
		subq	#1,d1
		and.b	#$1f,d1
		moveq	#1,d0
		lsl.l	d1,d0
		and.l	drives,d0
		beq	.senderr
			move.l	a0,-(sp)
			tos_dsetdrv	d1
			move.l	(sp)+,a0
.skipchdrv			
			tos_dsetpathm	a0
			move.l	#"OKAY",d0
			bra	.skiperr
.senderr		
		move.l	#"PERR",d0
.skiperr
	bsr	write_long
	bra	mainloop

do_rxprog
	lea	buf(pc),a0
	move.l	#headersiz,d0
	bsr	fast_server_read_block
	move.l	ph_tlen(a0),d0
	add.l	ph_dlen(a0),d0
	add.l	ph_blen(a0),d0
	add.l	ph_slen(a0),d0
	cmp.l	freemem,d0
	bls	.memok
	move.l	#"PERR",d0
	bsr	write_long
	bra	syncloop
.memok
;generate basepage
	move.l	#0,-(sp)	;env
	pea	cmdline
	move.l	buf+ph_prgflags(pc),-(sp)	;prgflags
	move.w	createmode,-(sp)
	move.w	#75,-(sp)	;pexec
	trap	#1
	lea	$10(sp),sp
	move.l	d0,a1
	move.l	d0,slavebp
	lea	buf(pc),a0
	lea	$100(a1),a2
	move.l	a2,bufptr
;a0=prog header - a1=basepage - a2=progstart
	move.l	a2,bp_tbase(a1)
	move.l	ph_tlen(a0),bp_tlen(a1)
	add.l	ph_tlen(a0),a2
	move.l	a2,bp_dbase(a1)
	move.l	ph_dlen(a0),bp_dlen(a1)
	add.l	ph_dlen(a0),a2
	move.l	a2,bp_bbase(a1)
	move.l	ph_blen(a0),bp_blen(a1)
	add.l	ph_slen(a0),a2
	move.w	ph_absflag(a0),saveabs
;a0=prog header - a1=basepage - a2=relostart
	move.l	a2,relostart
	move.l	#"OKAY",d0
	bsr	write_long

;receive program here
rxloop
	bsr	read_long
	tst.l	d0
	beq	readdone
	bsr	write_long

	move.l	bufptr(pc),a0
	add.l	d0,bufptr
	bsr	fast_server_read_block
	bsr	test_abort
	beq	abortprg
	bra	rxloop

readdone
	move.l	relostart(pc),a3
	move.l	slavebp(pc),a0
	tst.w	saveabs
	bne	relodone
relocate
	tst.l	(a3)
	beq.s	relodone	;no fixup -> relodone
	moveq	#0,d0
	move.l	bp_tbase(a0),d1
	move.l	d1,a2

	add.l	(a3)+,a2
.2	add.l	d1,(a2)		;longword+=text base
.4	move.b	(a3)+,d0	;get next fixup byte
	beq.s	relodone	; if (byte == 0) break;
	cmp.b	#1,d0		; if (byte == 1) a2 += 0xfe;
	bne.s	.3
	lea	254(a2),a2	;bump relocation pointer
	bra.s	.4
.3	add.l	d0,a2		;a2+=byte - could be moved to .2?
	bra.s	.2
relodone
	
	move.l	bp_bbase(a0),a2
	move.l	bp_blen(a0),d0
	moveq	#0,d1
.clrlp	move.l	d1,(a2)+
	subq.l	#4,d0
	bcc	.clrlp

	move.l	#0,-(sp)
	move.l	a0,-(sp)
	move.l	#0,-(sp)
	move.w	#6,-(sp)
	move.w	#75,-(sp)	;pexec
	trap	#1
	lea	$10(sp),sp
	bra	syncloop


keyflushtos
.loop	tos_cconis
        tst.w   d0
        beq     .empty
        tos_cnecin
        bra.s   .loop
.empty	rts

syncclient
	bsr	set_input_strobe_high
.waitforreadytogo1
	bsr	test_abort
	beq.s	userabort
	tos_supexec	get_busy_sup
	tst.b	d0
	beq.s	.waitforreadytogo1
	bra.s	wait_client
userabort
	moveq	#-1,d0
	rts

wait_client
	bsr	test_abort
	beq.s	userabort
	tos_supexec	get_busy_sup
	tst.b	d0
	bne.s	wait_client
	moveq	#1,d0
	rts
	
read_long
	bsr	wait_client
	move.l	a0,-(sp)
	lea	rxtmp(pc),a0
	moveq	#4,d0
	bsr	fast_server_read_block
	move.l	(a0),d0
	move.l	(sp)+,a0
	rts

write_long
	movem.l	a0/d0,-(sp)
	lea	rxtmp(pc),a0
	move.l	d0,(a0)
	moveq	#4,d0
	bsr	fast_server_write_block
	movem.l	(sp)+,a0/d0
	rts

test_abort	;ctrl+lshift+rshift
	tos_kbshift	#-1
	and.b	#$f,d0
	cmp.b	#1+2+4,d0
	seq	d0
	rts

	include	parserver.asm
	section	data
createmode	dc.w	7
cmdline		dc.b	0,0
toserr		dc.b	"PARRUN requires TOS 1.04+",$d,$a,0
done		dc.b	$d,$a,'program execution terminated',$d,$a,0
title		dc.b	'#PARRUN - CTRL+LSHIFT+RSHIFT to abort',$d,$a,0
wrongclient	dc.b	'Other side is not PARRUN Client',$d,$a,0
		even
	section	bss
slavebp 	ds.l	1
relostart	ds.l	1
bufptr		ds.l	1
blocksiz	ds.l	1
freemem		ds.l	1
drives		ds.l	1
saveabs		ds.w	1
rxtmp		ds.b	8
buf		ds.b	258
		rsreset
ph_branch	rs.w	1
ph_tlen 	rs.l	1
ph_dlen 	rs.l	1
ph_blen 	rs.l	1
ph_slen 	rs.l	1
ph_res1 	rs.l	1
ph_prgflags	rs.l	1
ph_absflag	rs.w	1
ph_mainprg	rs.w	1
		rsreset
bp_lowtpa	rs.l	1
bp_hitpa 	rs.l	1
bp_tbase 	rs.l	1
bp_tlen   	rs.l	1
bp_dbase 	rs.l	1
bp_dlen  	rs.l	1
bp_bbase 	rs.l	1
bp_blen  	rs.l	1
bp_dta   	rs.l	1
bp_parent	rs.l	1
bp_resrvd0	rs.l	1
bp_env   	rs.l	1

