/*
 * PARallel CoPy - written for transferring large files between any two machines
 * with parallel ports.
 *
 * Petr Stehlik (c) 1996,1997
 *
 */

/******************************************************************************/

#ifndef _PARCP_USB_H
#define _PARCP_USB_H

/******************************************************************************/
// communication
#define STROBE_HIGH	set_strobe(1)
#define STROBE_LOW	set_strobe(0)
#define IS_READY	get_busy()
#define SET_OUTPUT	set_mode(1)
#define SET_INPUT	set_mode(0)

#define USB_BLOCK_SIZE	60
int usb_init(const char *serial);
void usb_exit();
int set_mode(unsigned char output);
int set_strobe(unsigned char strobe);
int parcpusb_command(unsigned char command);
int get_busy();
int usb_set_client_read_size(long n);
int usb_set_server_read_size(long n);
int usb_set_client_write_size(long n, const unsigned char *);
int usb_set_server_write_size(long n, const unsigned char *);
int usb_read_block(unsigned char *block, long offset, int n);
int usb_write_block(const unsigned char *block, long offset, int n);
long client_read_block(unsigned char *block, long n);
long server_read_block(unsigned char *block, long n);
long client_write_block(const unsigned char *block, long n);
long server_write_block(const unsigned char *block, long n);

/******************************************************************************/

#endif	/* _PARCP_USB_H */
